﻿using Infragistics.Controls.Menus;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamDataTree_ICollectionView
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ICollectionView view;

        #region Proeprties
        
        public ObservableCollection<Continent> Data { get; set; }

        public ObservableCollection<Operator> Operators { get; set; }

        public ObservableCollection<Operator> FilterModes { get; set; }

        #endregion  
        public MainWindow()
        {
            InitializeComponent();
            Data = new ContinentCollection();

            DataContext = this;
        }

        private void XamDataTree_Loaded(object sender, RoutedEventArgs e)
        {
            view = CollectionViewSource.GetDefaultView(Data);
           
            xamDataTree.ItemsSource = view;
            		
        }     
          
    }

    public class ContinentCollection : ObservableCollection<Continent>
    {
        public ContinentCollection()
        {
            Add(new Continent
            {
                Name = "Africa",
                Children = new ObservableCollection<Country>()
                {
                    new Country()
                    {
                        Name = "Algeria",
                        Children = new ObservableCollection<City>()
                        {
                            new City {Name = "Algiers"},
                            new City {Name = "Oran"},
                        }
                    },
                    new Country()
                    {
                        Name = "Angola",
                        Children = new ObservableCollection<City>()
                        {
                            new City {Name = "Soyo"},
                            new City {Name = "Ndalatando"},
                            new City {Name = "Ambriz"},
                        }
                    },
                    new Country()
                    {
                        Name = "Cape Verde",
                        Children = new ObservableCollection<City>()
                        {
                            new City {Name = "Mindelo"},
                            new City {Name = "Assomada"},
                        }
                    }
                },
            });

            Add(new Continent
            {
                Name = "Asia",
                Children = new ObservableCollection<Country>()
                {
                    new Country()
                    {
                        Name = "Cambodia",
                        Children = new ObservableCollection<City>()
                        {
                            new City {Name = "Phnom Penh"},
                            new City {Name = "Koh Kong"},
                        }
                    },
                    new Country()
                    {
                        Name = "China",
                        Children = new ObservableCollection<City>()
                        {
                            new City {Name = "Shanghai"},
                            new City {Name = "Beijing"},
                            new City {Name = "Tianjin"},
                        }
                    },
                    new Country()
                    {
                        Name = "Japan",
                        Children = new ObservableCollection<City>()
                        {
                            new City {Name = "Tokyo"},
                            new City {Name = "Yokohama"},
                            new City {Name = "Sapporo"},
                        }
                    }
                }
            });

            Add(new Continent
            {
                Name = "Australia",
                Children = new ObservableCollection<Country>()
                {
                    new Country()
                    {
                        Name = "Australia",
                        Children = new ObservableCollection<City>()
                        {
                            new City {Name = "Sydney"},
                            new City {Name = "Melbourne"},
                            new City {Name = "Perth"},
                        }
                    }
                }
            });

            Add(new Continent
            {
                Name = "Europe",
                Children = new ObservableCollection<Country>()
                {
                    new Country()
                    {
                        Name = "Germany",
                        Children = new ObservableCollection<City>()
                        {
                            new City {Name = "Berlin"},
                            new City {Name = "Hamburg"}
                        }
                    },
                    new Country()
                    {
                        Name = "Italy",
                        Children = new ObservableCollection<City>()
                        {
                            new City {Name = "Milan"},
                            new City {Name = "Naples"},
                            new City {Name = "Rome"}
                        }
                    }
                },
            });
        }
    }

    public class Continent
    {
        public string Name { get; set; }
        public ObservableCollection<Country> Children { get; set; }
        public ICollectionView CountresView { get; set; }
    }

    public class Country
    {
        public string Name { get; set; }
        public ObservableCollection<City> Children { get; set; }
    }

    public class City
    {
        public string Name { get; set; }
    }

    public class Operator
    {
        public int ID { get; set; }
        public string Name { get; set; }
    }
      
}
